
#include <stdlib.h>
#include <stdio.h>

#include <windows.h>

#include <dbghelp.h>

void sw_backtrace2(void)
{
  const unsigned int max_entries = 10;
  void *entries[max_entries];
  unsigned short frames_nbr;

  void **frame = 0;
  unsigned int i = 0;

  printf("ASM\n");

  //asm ("movl %ebp, _frame;");
  /* asm volatile ("movl %%ebp, %0;" :"=m"(frame) : : ); */
  __asm__ __volatile__ ("movl %%ebp, %0" : : "m" (frame) : "memory");
  while(frame && i < max_entries) {
    entries[i++] = frame[1];
    frame = (void **)frame[0];
  }
  frames_nbr = i;
  for (i = 0; i < frames_nbr; i++)
    {
      char buf[100];
      printf(" [%u] 0x%p : ", i, entries[i]);
      snprintf(buf, 100, "addr2line.exe %p", entries[i]);
      system(buf);
      /* printf(" [%u] 0x%p\n", i, entries[i]); */
    }
}

void
sw_backtrace (void)
{
  void        *frames[50];
  unsigned short frames_nbr;
  unsigned int i;

  printf("CaptureStackBackTrace\n");

  frames_nbr = CaptureStackBackTrace(0, 50, frames, NULL);
  if (frames_nbr == 0)
    {
      printf("err %ld\n", GetLastError());
    }

  for (i = 0; i < frames_nbr; i++)
    {
      char buf[100];
      //      printf(" [%u] 0x%p\n", i, frames[i]);
      printf(" [%u] 0x%p : ", i, frames[i]);
      snprintf(buf, 100, "addr2line.exe %p", frames[i]);
      system(buf);
    }
}

void
sw_backtrace3(void)
{
#define max_entries 10
  void *entries[max_entries];
  CONTEXT context;
  DWORD options;
  STACKFRAME64 stack_frame;
  unsigned int num_frames = 0;
  unsigned int i;

  printf("StackWalk64\n");

  options = SymGetOptions();
  SymSetOptions(options |
                SYMOPT_LOAD_LINES |
                SYMOPT_FAIL_CRITICAL_ERRORS |
                SYMOPT_UNDNAME |
                SYMOPT_DEBUG);

  SymInitialize(GetCurrentProcess(), NULL, TRUE);

  RtlCaptureContext(&context);
  ZeroMemory(&stack_frame, sizeof(STACKFRAME64));
  stack_frame.AddrPC.Offset    = context.Eip;
  stack_frame.AddrPC.Mode      = AddrModeFlat;
  stack_frame.AddrFrame.Offset = context.Ebp;
  stack_frame.AddrFrame.Mode   = AddrModeFlat;
  stack_frame.AddrStack.Offset = context.Esp;
  stack_frame.AddrStack.Mode   = AddrModeFlat;

  while (1)
    {
      if (!StackWalk64(IMAGE_FILE_MACHINE_I386, GetCurrentProcess(),
                       GetCurrentThread(), &stack_frame, &context, NULL,
                       SymFunctionTableAccess64, SymGetModuleBase64, NULL))
        break;

      if (stack_frame.AddrPC.Offset == 0)
        break;

      entries[num_frames++] = (void *)stack_frame.AddrPC.Offset;
    }

  for (i = 0; i < num_frames; i++)
    {
      char buf[100];
      //      printf(" [%u] 0x%p\n", i, frames[i]);
      printf(" [%u] 0x%p : ", i, entries[i]);
      snprintf(buf, 100, "addr2line.exe %p", entries[i] - 1);
      system(buf);
    }
  SymCleanup(GetCurrentProcess());
}
